Index: src/sas/qtgui/Utilities/GridPanel.py
===================================================================
--- src/sas/qtgui/Utilities/GridPanel.py	(revision 3b3b40bf9d5056d902b19728c621dd2a4661d65f)
+++ src/sas/qtgui/Utilities/GridPanel.py	(revision 3b3b40bf9d5056d902b19728c621dd2a4661d65f)
@@ -0,0 +1,280 @@
+import os
+import time
+import logging
+import webbrowser
+
+from PyQt5 import QtCore, QtGui, QtWidgets
+
+import sas.qtgui.Utilities.GuiUtils as GuiUtils
+
+from sas.qtgui.Utilities.UI.GridPanelUI import Ui_GridPanelUI
+
+
+class BatchOutputPanel(QtWidgets.QMainWindow, Ui_GridPanelUI):
+    """
+    Class for stateless grid-like printout of model parameters for mutiple models
+    """
+    def __init__(self, parent = None, output_data=None):
+
+        super(BatchOutputPanel, self).__init__()
+        self.setupUi(self)
+
+        self.data = output_data
+        self.parent = parent
+        if hasattr(self.parent, "communicate"):
+            self.communicate = parent.communicate
+
+        self.addToolbarActions()
+
+        # file name for the dataset
+        self.grid_filename = ""
+
+        # context menu on the table
+        self.tblParams.setContextMenuPolicy(QtCore.Qt.CustomContextMenu)
+        self.tblParams.customContextMenuRequested.connect(self.showContextMenu)
+
+        # Fill in the table from input data
+        self.setupTable(output_data)
+
+        # Command buttons
+        self.cmdHelp.clicked.connect(self.onHelp)
+
+    def addToolbarActions(self):
+        """
+        Assing actions and callbacks to the File menu items
+        """
+        self.actionOpen.triggered.connect(self.actionLoadData)
+        self.actionOpen_with_Excel.triggered.connect(self.actionSendToExcel)
+        self.actionSave.triggered.connect(self.actionSaveFile)
+
+    def actionLoadData(self):
+        """
+        Open file load dialog and load a .csv file
+        """
+        datafile = QtWidgets.QFileDialog.getOpenFileName(
+            self, "Choose a file with results", "", "CSV files (*.csv)", None,
+            QtWidgets.QFileDialog.DontUseNativeDialog)[0]
+
+        if not datafile:
+            logging.info("No data file chosen.")
+            return
+
+        with open(datafile, 'r') as csv_file:
+            lines = csv_file.readlines()
+
+        self.setupTableFromCSV(lines)
+
+    def showContextMenu(self, position):
+        """
+        Show context specific menu in the tab table widget.
+        """
+        menu = QtWidgets.QMenu()
+        rows = [s.row() for s in self.tblParams.selectionModel().selectedRows()]
+        num_rows = len(rows)
+        if num_rows <= 0:
+            return
+        # Find out which items got selected and in which row
+        # Select for fitting
+
+        self.actionPlotResults = QtWidgets.QAction(self)
+        self.actionPlotResults.setObjectName("actionPlot")
+        self.actionPlotResults.setText(QtCore.QCoreApplication.translate("self", "Plot selected fits."))
+
+        menu.addAction(self.actionPlotResults)
+
+        # Define the callbacks
+        self.actionPlotResults.triggered.connect(self.plotFits)
+        try:
+            menu.exec_(self.tblParams.viewport().mapToGlobal(position))
+        except AttributeError as ex:
+            logging.error("Error generating context menu: %s" % ex)
+        return
+
+    def onHelp(self):
+        """
+        Open a local url in the default browser
+        """
+        location = GuiUtils.HELP_DIRECTORY_LOCATION
+        url = "/user/sasgui/perspectives/fitting/fitting_help.html#batch-fit-mode"
+        try:
+            webbrowser.open('file://' + os.path.realpath(location+url))
+        except webbrowser.Error as ex:
+            logging.warning("Cannot display help. %s" % ex)
+
+    def plotFits(self):
+        """
+        Plot selected fits by sending signal to the parent
+        """
+        rows = [s.row() for s in self.tblParams.selectionModel().selectedRows()]
+        data = self.dataFromTable(self.tblParams)
+        # data['Data'] -> ['filename1', 'filename2', ...]
+        # look for the 'Data' column and extract the filename
+        for row in rows:
+            try:
+                filename = data['Data'][row]
+                # emit a signal so the plots are being shown
+                self.communicate.plotFromFilenameSignal.emit(filename)
+            except (IndexError, AttributeError):
+                # data messed up.
+                return
+
+    def dataFromTable(self, table):
+        """
+        Creates a dictionary {<parameter>:[list of values]} from the parameter table
+        """
+        assert(isinstance(table, QtWidgets.QTableWidget))
+        params = {}
+        #return {"sld_solvent":[1.2, 2.0, 0.0], "scale":[1.0, 2.0, 3.0]}
+        for column in range(table.columnCount()):
+            #pass
+            value = [table.item(row, column).data(0) for row in range(table.rowCount())]
+            key = table.horizontalHeaderItem(column).data(0)
+            params[key] = value
+        return params
+
+    def actionSendToExcel(self):
+        """
+        Generates a .csv file and opens the default CSV reader
+        """
+        if not self.grid_filename:
+            import tempfile
+            tmpfile = tempfile.NamedTemporaryFile(delete=False, mode="w+", suffix=".csv")
+            self.grid_filename = tmpfile.name
+            data = self.dataFromTable(self.tblParams)
+            t = time.localtime(time.time())
+            time_str = time.strftime("%b %d %H:%M of %Y", t)
+            details = "File Generated by SasView " 
+            details += "on %s.\n" % time_str
+            self.writeBatchToFile(data=data, tmpfile=tmpfile, details=details)
+            tmpfile.close()
+
+        try:
+            from win32com.client import Dispatch
+            excel_app = Dispatch('Excel.Application')
+            excel_app.Workbooks.Open(self.grid_filename)
+            excel_app.Visible = 1
+        except Exception as ex:
+            msg = "Error occured when calling Excel.\n"
+            msg += ex
+            self.parent.communicate.statusBarUpdateSignal.emit(msg)
+
+    def actionSaveFile(self):
+        """
+        Generate a .csv file and dump it do disk
+        """
+        t = time.localtime(time.time())
+        time_str = time.strftime("%b %d %H %M of %Y", t)
+        default_name = "Batch_Fitting_"+time_str+".csv"
+
+        wildcard = "CSV files (*.csv);;"
+        kwargs = {
+            'caption'   : 'Save As',
+            'directory' : default_name,
+            'filter'    : wildcard,
+            'parent'    : None,
+        }
+        # Query user for filename.
+        filename_tuple = QtWidgets.QFileDialog.getSaveFileName(**kwargs)
+        filename = filename_tuple[0]
+
+        # User cancelled.
+        if not filename:
+            return
+        data = self.dataFromTable(self.tblParams)
+        details = "File generated by SasView\n"
+        with open(filename, 'w') as csv_file:
+            self.writeBatchToFile(data=data, tmpfile=csv_file, details=details)
+
+    def setupTableFromCSV(self, csv_data):
+        """
+        Create tablewidget items and show them, based on params
+        """
+        # Clear existing display
+        self.tblParams.clear()
+        # headers
+        param_list = csv_data[1].rstrip().split(',')
+        for i, param in enumerate(param_list):
+            self.tblParams.setHorizontalHeaderItem(i, QtWidgets.QTableWidgetItem(param))
+
+        # first - Chi2 and data filename
+        for i_row, row in enumerate(csv_data[2:]):
+            for i_col, col in enumerate(row.rstrip().split(',')):
+                self.tblParams.setItem(i_row, i_col, QtWidgets.QTableWidgetItem(col))
+
+        self.tblParams.resizeColumnsToContents()
+
+    def setupTable(self, data):
+        """
+        Create tablewidget items and show them, based on params
+        """
+        # headers
+        model = data[0][0]
+        param_list = [m for m in model.model.params.keys() if ":" not in m]
+
+        # Check if 2D model. If not, remove theta/phi
+
+        rows = len(data)
+        columns = len(param_list)
+        self.tblParams.setColumnCount(columns+2)
+        self.tblParams.setRowCount(rows)
+
+        param_list.insert(0, "Data")
+        param_list.insert(0, "Chi2")
+        for i, param in enumerate(param_list):
+            self.tblParams.setHorizontalHeaderItem(i, QtWidgets.QTableWidgetItem(param))
+
+        # first - Chi2 and data filename
+        for i_row, row in enumerate(data):
+            # each row corresponds to a single fit
+            chi2 = row[0].fitness
+            filename = ""
+            if hasattr(row[0].data, "sas_data"):
+                filename = row[0].data.sas_data.filename
+            self.tblParams.setItem(i_row, 0, QtWidgets.QTableWidgetItem(GuiUtils.formatNumber(chi2, high=True)))
+            self.tblParams.setItem(i_row, 1, QtWidgets.QTableWidgetItem(str(filename)))
+            # Now, all the parameters
+            for i_col, param in enumerate(param_list[2:]):
+                if param in row[0].param_list:
+                    # parameter is on the to-optimize list - get the optimized value
+                    par_value = row[0].pvec[row[0].param_list.index(param)]
+                    # should we parse out errors here and store them?
+                else:
+                    # parameter was not varied
+                    par_value = row[0].model.params[param]
+                self.tblParams.setItem(i_row, i_col+2, QtWidgets.QTableWidgetItem(
+                    GuiUtils.formatNumber(par_value, high=True)))
+
+        self.tblParams.resizeColumnsToContents()
+
+    def writeBatchToFile(self, data, tmpfile, details=""):
+        """
+        Helper to write result from batch into cvs file
+        """
+        name = tmpfile.name
+        if data is None or name is None or name.strip() == "":
+            return
+        _, ext = os.path.splitext(name)
+        separator = "\t"
+        if ext.lower() == ".csv":
+            separator = ","
+        tmpfile.write(details)
+        for col_name in data.keys():
+            tmpfile.write(col_name)
+            tmpfile.write(separator)
+        tmpfile.write('\n')
+        max_list = [len(value) for value in data.values()]
+        if len(max_list) == 0:
+            return
+        max_index = max(max_list)
+        index = 0
+        while index < max_index:
+            for value_list in data.values():
+                if index < len(value_list):
+                    tmpfile.write(str(value_list[index]))
+                    tmpfile.write(separator)
+                else:
+                    tmpfile.write('')
+                    tmpfile.write(separator)
+            tmpfile.write('\n')
+            index += 1
+
Index: src/sas/qtgui/Utilities/GuiUtils.py
===================================================================
--- src/sas/qtgui/Utilities/GuiUtils.py	(revision 63319b0e1635f70a44346bc676740b77b0aa7102)
+++ src/sas/qtgui/Utilities/GuiUtils.py	(revision 3b3b40bf9d5056d902b19728c621dd2a4661d65f)
@@ -213,4 +213,7 @@
     plotRequestedSignal = QtCore.pyqtSignal(list)
 
+    # Plot from file names
+    plotFromFilenameSignal = QtCore.pyqtSignal(str)
+
     # Plot update requested from a perspective
     plotUpdateSignal = QtCore.pyqtSignal(list)
@@ -236,4 +239,7 @@
     # Send result of Data Operation Utility panel to Data Explorer
     updateModelFromDataOperationPanelSignal = QtCore.pyqtSignal(QtGui.QStandardItem, dict)
+
+    # Notify about a new custom plugin being written/deleted/modified
+    customModelDirectoryChanged = QtCore.pyqtSignal()
 
 def updateModelItemWithPlot(item, update_data, name=""):
@@ -872,4 +878,27 @@
         raise TypeError
 
+def findNextFilename(filename, directory):
+    """
+    Finds the next available (non-existing) name for 'filename' in 'directory'.
+    plugin.py -> plugin (n).py  - for first 'n' for which the file doesn't exist
+    """
+    basename, ext = os.path.splitext(filename)
+    # limit the number of copies
+    MAX_FILENAMES = 1000
+    # Start with (1)
+    number_ext = 1
+    proposed_filename = ""
+    found_filename = False
+    # Find the next available filename or exit if too many copies
+    while not found_filename or number_ext > MAX_FILENAMES:
+        proposed_filename = basename + " ("+str(number_ext)+")" + ext
+        if os.path.exists(os.path.join(directory, proposed_filename)):
+            number_ext += 1
+        else:
+            found_filename = True
+
+    return proposed_filename
+
+
 class DoubleValidator(QtGui.QDoubleValidator):
     """
Index: src/sas/qtgui/Utilities/LocalConfig.py
===================================================================
--- src/sas/qtgui/Utilities/LocalConfig.py	(revision c3eb8580d07c18adae8887b6238dace7905f23e1)
+++ src/sas/qtgui/Utilities/LocalConfig.py	(revision 3b3b40bf9d5056d902b19728c621dd2a4661d65f)
@@ -141,4 +141,8 @@
 # Time out for updating sasview
 UPDATE_TIMEOUT = 2
+
+# Logging levels to disable, if any
+DISABLE_LOGGING = logging.DEBUG
+
 def printEVT(message):
     """
Index: src/sas/qtgui/Utilities/ModelEditor.py
===================================================================
--- src/sas/qtgui/Utilities/ModelEditor.py	(revision 3b3b40bf9d5056d902b19728c621dd2a4661d65f)
+++ src/sas/qtgui/Utilities/ModelEditor.py	(revision 3b3b40bf9d5056d902b19728c621dd2a4661d65f)
@@ -0,0 +1,60 @@
+# global
+import sys
+import os
+import types
+import webbrowser
+
+from PyQt5 import QtCore
+from PyQt5 import QtGui
+from PyQt5 import QtWidgets
+
+import sas.qtgui.Utilities.GuiUtils as GuiUtils
+from sas.qtgui.Utilities.PythonSyntax import PythonHighlighter
+
+from sas.qtgui.Utilities.UI.ModelEditor import Ui_ModelEditor
+
+class ModelEditor(QtWidgets.QDialog, Ui_ModelEditor):
+    """
+    Class describing the "advanced" model editor.
+    This is a simple text browser allowing for editing python and
+    supporting simple highlighting.
+    """
+    modelModified = QtCore.pyqtSignal()
+    def __init__(self, parent=None):
+        super(ModelEditor, self).__init__(parent)
+        self.setupUi(self)
+
+        self.setupWidgets()
+
+        self.addSignals()
+
+    def setupWidgets(self):
+        """
+        Set up dialog widgets.
+        Here - just the highlighter connected to the text edit.
+        """
+        self.highlight = PythonHighlighter(self.txtEditor.document())
+
+    def addSignals(self):
+        """
+        Respond to signals in the widget
+        """
+        self.txtEditor.textChanged.connect(self.onEdit)
+
+    def onEdit(self):
+        """
+        Respond to changes in the text browser.
+        """
+        # We have edited the model - notify the parent.
+        if self.txtEditor.toPlainText() != "":
+            self.modelModified.emit()
+        pass
+
+    def getModel(self):
+        """
+        Return the current model, as displayed in the window
+        """
+        model = {'text':self.txtEditor.toPlainText()}
+        model['filename'] = ""
+        return model
+
Index: src/sas/qtgui/Utilities/PluginDefinition.py
===================================================================
--- src/sas/qtgui/Utilities/PluginDefinition.py	(revision 3b3b40bf9d5056d902b19728c621dd2a4661d65f)
+++ src/sas/qtgui/Utilities/PluginDefinition.py	(revision 3b3b40bf9d5056d902b19728c621dd2a4661d65f)
@@ -0,0 +1,174 @@
+# global
+import sys
+import os
+import logging 
+
+from PyQt5 import QtCore
+from PyQt5 import QtGui
+from PyQt5 import QtWidgets
+
+from sas.qtgui.Utilities.UI.PluginDefinitionUI import Ui_PluginDefinition
+from sas.qtgui.Utilities.PythonSyntax import PythonHighlighter
+
+# txtName
+# txtDescription
+# chkOverwrite
+# tblParams
+# tblParamsPD
+# txtFunction
+
+class PluginDefinition(QtWidgets.QDialog, Ui_PluginDefinition):
+    """
+    Class describing the "simple" plugin editor.
+    This is a simple series of widgets allowing for specifying
+    model form and parameters.
+    """
+    modelModified = QtCore.pyqtSignal()
+    def __init__(self, parent=None):
+        super(PluginDefinition, self).__init__(parent)
+        self.setupUi(self)
+
+        # globals
+        self.initializeModel()
+        # internal representation of the parameter list
+        # {<row>: (<parameter>, <value>)}
+        self.parameter_dict = {}
+        self.pd_parameter_dict = {}
+
+        # Initialize signals
+        self.addSignals()
+
+        # Initialize widgets
+        self.addWidgets()
+
+    def addWidgets(self):
+        """
+        Initialize various widgets in the dialog
+        """
+        # Set the tooltip
+        hint_function = "#Example:\n\n"
+        hint_function += "if x <= 0:\n"
+        hint_function += "    y = A + B\n"
+        hint_function += "else:\n"
+        hint_function += "    y = A + B * cos(2 * pi * x)\n"
+        hint_function += "return y\n"
+        self.txtFunction.setToolTip(hint_function)
+        # Initial text in the function table
+        text = \
+"""y = x
+
+return y
+"""
+        self.txtFunction.insertPlainText(text)
+
+        # Validators
+        #rx = QtCore.QRegExp(r'^[\w,\s-]+$')
+        #rx = QtCore.QRegExp("[a-z-A-Z_]+")
+        rx = QtCore.QRegExp("^[A-Za-z0-9_]*$")
+
+        txt_validator = QtGui.QRegExpValidator(rx)
+        self.txtName.setValidator(txt_validator)
+        self.highlight = PythonHighlighter(self.txtFunction.document())        
+
+    def initializeModel(self):
+        """
+        Define the dictionary for internal data representation
+        """
+        # Define the keys
+        self.model = {
+            'filename':'',
+            'overwrite':False,
+            'description':'',
+            'parameters':{},
+            'pd_parameters':{},
+            'text':''}
+
+    def addSignals(self):
+        """
+        Define slots for widget signals
+        """
+        self.txtName.editingFinished.connect(self.onPluginNameChanged)
+        self.txtDescription.editingFinished.connect(self.onDescriptionChanged)
+        self.tblParams.cellChanged.connect(self.onParamsChanged)
+        self.tblParamsPD.cellChanged.connect(self.onParamsPDChanged)
+        # QTextEdit doesn't have a signal for edit finish, so we respond to text changed.
+        # Possibly a slight overkill.
+        self.txtFunction.textChanged.connect(self.onFunctionChanged)
+        self.chkOverwrite.toggled.connect(self.onOverwrite)
+
+    def onPluginNameChanged(self):
+        """
+        Respond to changes in plugin name
+        """
+        self.model['filename'] = self.txtName.text()
+        self.modelModified.emit()
+
+    def onDescriptionChanged(self):
+        """
+        Respond to changes in plugin description
+        """
+        self.model['description'] = self.txtDescription.text()
+        self.modelModified.emit()
+
+    def onParamsChanged(self, row, column):
+        """
+        Respond to changes in non-polydisperse parameter table
+        """
+        param = value = None
+        if self.tblParams.item(row, 0):
+            param = self.tblParams.item(row, 0).data(0)
+        if self.tblParams.item(row, 1):
+            value = self.tblParams.item(row, 1).data(0)
+
+        # If modified, just update the dict
+        self.parameter_dict[row] = (param, value)
+        self.model['parameters'] = self.parameter_dict
+
+        # Check if the update was Value for last row. If so, add a new row
+        if column == 1 and row == self.tblParams.rowCount()-1:
+            # Add a row
+            self.tblParams.insertRow(self.tblParams.rowCount())
+        self.modelModified.emit()
+
+    def onParamsPDChanged(self, row, column):
+        """
+        Respond to changes in non-polydisperse parameter table
+        """
+        param = value = None
+        if self.tblParamsPD.item(row, 0):
+            param = self.tblParamsPD.item(row, 0).data(0)
+        if self.tblParamsPD.item(row, 1):
+            value = self.tblParamsPD.item(row, 1).data(0)
+
+        # If modified, just update the dict
+        self.pd_parameter_dict[row] = (param, value)
+        self.model['pd_parameters'] = self.pd_parameter_dict
+
+        # Check if the update was Value for last row. If so, add a new row
+        if column == 1 and row == self.tblParamsPD.rowCount()-1:
+            # Add a row
+            self.tblParamsPD.insertRow(self.tblParamsPD.rowCount())
+        self.modelModified.emit()
+
+
+    def onFunctionChanged(self):
+        """
+        Respond to changes in function body
+        """
+        # keep in mind that this is called every time the text changes.
+        # mind the performance!
+        self.model['text'] = self.txtFunction.toPlainText().lstrip().rstrip()
+        self.modelModified.emit()
+
+    def onOverwrite(self):
+        """
+        Respond to change in file overwrite checkbox
+        """
+        self.model['overwrite'] = self.chkOverwrite.isChecked()
+        self.modelModified.emit()
+
+    def getModel(self):
+        """
+        Return the current plugin model
+        """
+        return self.model
Index: src/sas/qtgui/Utilities/PluginManager.py
===================================================================
--- src/sas/qtgui/Utilities/PluginManager.py	(revision 3b3b40bf9d5056d902b19728c621dd2a4661d65f)
+++ src/sas/qtgui/Utilities/PluginManager.py	(revision 3b3b40bf9d5056d902b19728c621dd2a4661d65f)
@@ -0,0 +1,144 @@
+# global
+import sys
+import os
+import logging 
+from shutil import copyfile
+
+from PyQt5 import QtCore
+from PyQt5 import QtGui
+from PyQt5 import QtWidgets
+
+from sas.sascalc.fit import models
+from sas.qtgui.Perspectives.Fitting import ModelUtilities
+from sas.qtgui.Utilities.TabbedModelEditor import TabbedModelEditor
+import sas.qtgui.Utilities.GuiUtils as GuiUtils
+
+from sas.qtgui.Utilities.UI.PluginManagerUI import Ui_PluginManagerUI
+
+
+class PluginManager(QtWidgets.QDialog, Ui_PluginManagerUI):
+    """
+    Class describing the model plugin manager.
+    This is a simple list widget allowing for viewing/adding/deleting custom models.
+    """
+    def __init__(self, parent=None):
+        super(PluginManager, self).__init__()
+        self.setupUi(self)
+
+        self.parent = parent
+        self.cmdDelete.setEnabled(False)
+        self.cmdEdit.setEnabled(False)
+        self.cmdDuplicate.setEnabled(False)
+
+        # globals
+        self.readModels()
+
+        # internal representation of the parameter list
+        # {<row>: (<parameter>, <value>)}
+        self.plugin_dict = {}
+
+        # Initialize signals
+        self.addSignals()
+
+    def readModels(self):
+        """
+        Read in custom models from the default location
+        """
+        self.lstModels.clear()
+        plugins = ModelUtilities._find_models()
+        models = list(plugins.keys())
+        self.lstModels.addItems(models)
+
+    def addSignals(self):
+        """
+        Define slots for widget signals
+        """
+        self.cmdOK.clicked.connect(self.accept)
+        self.cmdDelete.clicked.connect(self.onDelete)
+        self.cmdAdd.clicked.connect(self.onAdd)
+        self.cmdDuplicate.clicked.connect(self.onDuplicate)
+        self.cmdEdit.clicked.connect(self.onEdit)
+        self.cmdHelp.clicked.connect(self.onHelp)
+        self.lstModels.selectionModel().selectionChanged.connect(self.onSelectionChanged)
+        self.parent.communicate.customModelDirectoryChanged.connect(self.readModels)
+
+    def onSelectionChanged(self):
+        """
+        Respond to row selection
+        """
+        rows = len(self.lstModels.selectionModel().selectedRows())
+        self.cmdDelete.setEnabled(rows>0)
+        self.cmdEdit.setEnabled(rows==1)
+        self.cmdDuplicate.setEnabled(rows>0)
+
+    def onDelete(self):
+        """
+        Remove the file containing the selected plugin
+        """
+        plugins_to_delete = [s.data() for s in self.lstModels.selectionModel().selectedRows()]
+
+        delete_msg = "Are you sure you want to remove the selected plugins?"
+        reply = QtWidgets.QMessageBox.question(
+            self,
+            'Warning',
+            delete_msg,
+            QtWidgets.QMessageBox.Yes,
+            QtWidgets.QMessageBox.No)
+
+        # Exit if no
+        if reply == QtWidgets.QMessageBox.No:
+            return
+
+        for plugin in plugins_to_delete:
+            name = os.path.join(ModelUtilities.find_plugins_dir(), plugin + ".py")
+            os.remove(name)
+
+        self.parent.communicate.customModelDirectoryChanged.emit()
+
+    def onAdd(self):
+        """
+        Show the add new model dialog
+        """
+        self.add_widget = TabbedModelEditor(parent=self.parent)
+        self.add_widget.show()
+
+    def onDuplicate(self):
+        """
+        Creates a copy of the selected model(s)
+        """
+
+        plugins_to_copy = [s.data() for s in self.lstModels.selectionModel().selectedRows()]
+        plugin_dir = ModelUtilities.find_plugins_dir()
+        for plugin in plugins_to_copy:
+            src_filename = plugin + ".py"
+            src_file = os.path.join(plugin_dir, src_filename)
+            dst_filename = GuiUtils.findNextFilename(src_filename, plugin_dir)
+            if not dst_filename:
+                logging.error("Could not find appropriate filename for "+src_file)
+            dst_file = os.path.join(plugin_dir, dst_filename)
+            copyfile(src_file, dst_file)
+            self.parent.communicate.customModelDirectoryChanged.emit()
+
+    def onEdit(self):
+        """
+        Show the edit existing model dialog
+        """
+        plugin_location = models.find_plugins_dir()
+        # GUI assured only one row selected. Pick up the only element in list.
+        try:
+            model_to_edit = self.lstModels.selectionModel().selectedRows()[0].data()
+        except Exception:
+            # Something wrong with model, return
+            return
+        name = os.path.join(plugin_location, model_to_edit + ".py")
+        self.edit_widget = TabbedModelEditor(parent=self.parent, edit_only=True)
+        self.edit_widget.loadFile(name)
+        self.edit_widget.show()
+
+    def onHelp(self):
+        """
+        Show the help page in the default browser
+        """
+        location = "/user/sasgui/perspectives/fitting/fitting_help.html#new-plugin-model"
+        self.parent.showHelp(location)
+                
